unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Spin;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Image1: TImage;
    Panel1: TPanel;
    Button1: TButton;
    Button3: TButton;
    Button4: TButton;
    Timer1: TTimer;
    Panel2: TPanel;
    ListBox1: TListBox;
    Panel3: TPanel;
    Image2: TImage;
    TabSheet3: TTabSheet;
    Panel4: TPanel;
    Button2: TButton;
    Image3: TImage;
    CheckBox1: TCheckBox;
    SpinEdit1: TSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
    Bugs, DblPointUnit;

{$R *.dfm}



procedure TForm1.Button1Click(Sender: TObject);
var
    i: integer;
    aCreature: TCreature;
begin
    aCreature := TBug.Create;
    for i := 0 to 9 do begin
        aCreature := TBacteria.Create;
    end;
    Timer1.Enabled := True;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
    aWorld.mUpdate;
    if CheckBox1.Checked then
        if aWorld.fPopulation.Last > SpinEdit1.Value then
            Timer1.Enabled := False;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
    aWorld.mUpdate;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
    Timer1.Enabled := not Timer1.Enabled;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    Image1.ControlStyle := Image1.ControlStyle + [csOpaque];
    Image2.ControlStyle := Image2.ControlStyle + [csOpaque];
    Image3.ControlStyle := Image3.ControlStyle + [csOpaque];
end;

procedure TForm1.FormShow(Sender: TObject);
begin
    aWorld := TCreatureWorld.Create(Image1.Width, Image1.Height, Image1.Canvas);
end;

procedure TForm1.PageControl1Change(Sender: TObject);
var
    i: integer;
begin

    Timer1.Enabled := False;

    case PageControl1.TabIndex of
    1:  begin
            ListBox1.Clear;
            for i := 0 to aWorld.fCreatureList.Count - 1 do begin
                ListBox1.Items.Add('Creature' + IntToStr(i));
            end;
        end;
    end;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
var
    i: integer;
    aCreature: TCreature;
    aPoints  : array of TDblPoint;
begin
    if ListBox1.ItemIndex = -1 then Exit;
    aCreature := aWorld.fCreatureList.Items[ListBox1.ItemIndex];

    with Image2 do begin
        Canvas.Brush.Color := clWindow;
        Canvas.FillRect(Rect(0, 0, Width, Height));
    end;

    ConnectDblPoint(aCreature.fPosHistory, Image2.Canvas);

    Image2.Canvas.Pen.Color := clBlue;
    if aCreature.ClassType = TBug then begin
        SetLength(aPoints, Length(TBug(aCreature).fchrom));
        for i := Low(aPoints) to High(aPoints) do begin
            aPoints[i] := GetEndPoint(DblPoint(50, 50), TBug(aCreature).fchrom[i] * 100, PI * 2 * i / Length(aPoints));
        end;
        Canvas.Pen.Color := clRed;
        DrawRadial(DblPoint(50, 50), aPoints, Image2.Canvas);
    end;

end;

procedure TForm1.Button2Click(Sender: TObject);
var
    i: integer;
    PopArray: array of TDblPoint;
begin
    with Image3 do begin
        Canvas.Brush.Color := clWindow;
        Canvas.FillRect(Rect(0, 0, Width, Height));
        SetLength(PopArray, aWorld.fPopulation.Count);
        for i := 0 to aWorld.fPopulation.Count - 1 do begin
            PopArray[i] := DblPoint(i, aWorld.fPopulation.IntItems[i]);
        end;
        ConnectDblPoint(PopArray, Canvas);
    end;

end;

end.
